{ WebLox unit for dynamic list functions
  (C)2000/2001 by gerd@dg4fac.de Version 0.8
  created 11.11.2000 for fpk-Pascal under
  SuSe-Linux 7.0, last change 05.01.2002
}

Unit weblist;

Interface

Const
  nLists=26;
  ProtList=21;
  { Lists }
  ListIp=1;
  ListMultVis=2;
  ListCountry=3;
  ListPath=4;
  ListFiles=5;
  ListFilesNonGra=6;
  ListJpeg=7;
  ListGif=8;
  ListEntryPages=9;
  ListCheatPages=10;
  ListRc=11;
  List404=12;
  ListRefi=13;
  ListRefe=14;
  ListSE=15;
  ListST=16;
  ListBt=17;
  ListBv=18;
  ListOp=19;
  ListHours=20;
  ListDetail=21;
  ListHtmlFiles=22;
  ListBrowser=23;
  ListOpSys=24;
  ListBrowserU=25;
  ListOpSysU=26;
  { Sorting options }
  nSortOpts=6;
  Unsorted=0;
  SortByString=1;
  SortByNumber=2;
  SortByBytes=3;
  SortByVisits=4;
  SortByStringDw=5;
  SortByDifferent=6;

Type
  pTListElement=^TListElement;
  TListElement = Record
    s:String;
    sEntry:String;
    n,          { number of accesses }
    nt,         { last access time   }
    nv:LongWord; { number of visits   }
    nb:LongInt; { number of bytes    }
    prev,next:pTListElement;
    End;
  TList = Record
    s:String;
    p:pTListElement;
    SortedBy:Byte;
    c1,c2:Char;
    ItemCount,ns,nks,nvs:LongInt;
    End;

Var
  aTitle:Array[1..nLists+1] Of String;
  sAbbrev:String;
  sSortOpt:Array[1..nSortOpts] Of String;
  sSortAbbrev:String;
  x:TListElement; { communication with unit weblist.pas }

Function ListAddNew(List:LongInt):Boolean;
Procedure ListSort(List:LongInt;SortBy:Byte);
Function ListGetElement(List,Element:LongInt):Boolean;
Function ListGetList(List:LongInt):TList;
Function ListDel(List,Element:LongInt):Boolean;
Procedure ListClearAll;
Function ListExchStr(List:LongInt;Var s1,s2:String):Boolean;
Procedure ListSetTitle(List:LongInt;Var s:String);
Procedure ListSetC1(List:LongInt;c:Char);
Procedure ListResetAllN(List:LongInt);
Procedure ListClearProtectedLists;
Function ListFindString(List:LongInt;Var s:String):String;
Procedure ListAddUrlNames;

Implementation
Uses webstring,ip2url,CRT;

Var
  alist:Array[1..nLists] Of TList;
  k:LongInt;

Function ListGetList(List:LongInt):TList;
Begin
ListGetList:=aList[List];
End;

Procedure ListSetTitle(List:LongInt;Var s:String);
Begin
aList[List].s:=s;
End;

Procedure ListSetC1(List:LongInt;c:Char);
Begin
aList[List].C1:=c;
End;

Procedure ListAddUrlNames;
Var p:pTListElement;
Begin
Write(ws[igrpws[msgGroup].ia+41],' ');
p:=aList[Listip].p;
While p<>NIL Do
  Begin
  FindIpCreateIfNone(p^.s,'',0);
  p:=p^.next;
  End;
Writeln(ws[igrpws[msgGroup].ia+18]);
TranslateAllMissingIps;
Write(ws[igrpws[msgGroup].ia+42],' ');
p:=aList[ListIp].p;
While (p<>NIL) Do
  Begin
  p^.s:=p^.s+'='+FindIp(p^.s);
  p:=p^.next;
  End;
Writeln(ws[igrpws[msgGroup].ia+18]);
End;

Function ListExchStr(List:LongInt;Var s1,s2:String):Boolean;
Var p:pTListElement;
Begin
p:=alist[List].p;
While (p<>NIL) And (p^.s<>s1) Do p:=p^.next;
If p<>NIL Then p^.s:=s2;
ListExchStr:=p<>NIL;
End;

Procedure ListResetAllN(List:LongInt);
Var pp:pTListElement;
Begin
pp:=aList[List].p;
While pp<>NIL Do With pp^ Do
  Begin
  n:=0;
  nb:=0;
  nv:=0;
  pp:=next;
  End;
With aList[List] Do
  Begin
  ns:=0;
  nks:=0;
  nvs:=0;
  End;
End;

Function ListGetAdrs(List,Element:LongInt):pTListElement;
Var k:LongInt;
  p:pTListElement;
Begin
k:=1;
p:=alist[List].p;
If p<>NIL Then While (k<Element) And (p^.next<>NIL) Do
  Begin
  Inc(k);
  p:=p^.next;
  End;
If k=Element Then ListGetAdrs:=p Else ListGetAdrs:=NIL;
End;

Function ListDel(List,Element:LongInt):Boolean;
Var pv,p,pn:pTListElement;
Begin
p:=ListGetAdrs(List,Element);
If p<>NIL Then
  Begin
  With aList[List] Do
    Begin
    Dec(ItemCount);
    ns:=ns-p^.n;
    nks:=nks-p^.nb;
    nvs:=nvs-p^.nv;
    End;
  pv:=p^.prev;
  pn:=p^.next;
  Dispose(p);
  If pv=NIL Then alist[List].p:=pn Else pv^.next:=pn;
  If pn<>NIL Then pn^.prev:=pv;
  ListDel:=True;
  End Else
  ListDel:=False;
End;

Procedure ListSort(List:LongInt;SortBy:Byte);
Var p,pn,p0,p1,p2,p3:pTListElement;
  vert:Boolean;
Begin
p:=aList[List].p;
If p<>NIL Then
  Begin
  pn:=p^.next;
  While pn<>NIL Do
    Begin
    Case SortBy Of
      SortByString:vert:=pn^.s<p^.s;
      SortByNumber:vert:=pn^.n>p^.n;
      SortByBytes:vert:=pn^.nb>p^.nb;
      SortByVisits:vert:=pn^.nv>p^.nv;
      SortByStringDw:vert:=pn^.s>p^.s;
      Else
      vert:=False;
      End;
    If vert Then
      Begin
      p0:=p^.prev;
      p1:=p;
      p2:=pn;
      p3:=pn^.next;
      p1^.prev:=p2;
      p1^.next:=p3;
      p2^.prev:=p0;
      p2^.next:=p1;
      If p0<>NIL Then
        Begin
        p0^.next:=p2;
        p:=p0;
        End Else
        Begin
        aList[List].p:=p2;
        p2^.prev:=NIL;
        p:=p2;
        End;
      If p3<>NIL Then p3^.prev:=p1;
      End Else
      p:=pn;
    pn:=p^.next;
    End;
  End;
aList[List].SortedBy:=SortBy;
With aList[List] Do c2:=sSortAbbrev[SortedBy+1];
End;

Procedure ListClearList(List:LongInt);
Var p,pn:pTListElement;
Begin
p:=alist[List].p;
While p<>NIL Do
  Begin
  pn:=p^.next;
  Dispose(p);
  p:=pn;
  End;
With alist[List] Do
  Begin
  p:=NIL;
  SortedBy:=Unsorted;
  c2:='u';
  ItemCount:=0;
  ns:=0;
  nks:=0;
  nvs:=0;
  End;
End;

Procedure ListClearAll;
Var
  k:LongInt;
Begin
For k:=1 To ProtList-1 Do If alist[k].p<>NIL Then
  ListClearList(k);
End;

Procedure ListClearProtectedLists;
Var k:LongInt;
Begin
For k:=ProtList To nLists Do ListClearList(k);
End;

Function ListGetElement(List,Element:LongInt):Boolean;
Var p:pTListElement;
Begin
p:=ListGetAdrs(List,Element);
If (p<>NIL) Then
  Begin
  With p^ Do
    Begin
    x.s:=s;
    x.sEntry:=sEntry;
    x.n:=n;
    x.nb:=nb;
    x.nt:=nt;
    x.nv:=nv;
    End;
  ListGetElement:=True;
  End Else
  ListGetElement:=False;
End;

Function CreateNewListElement:pTListElement;
Var pn:pTListElement;
Begin
pn:=New(pTListElement);
With pn^ Do
  Begin
  s:=x.s;
  If x.sEntry<>'' Then sEntry:=x.sEntry;
  n:=x.n;
  nb:=x.nb;
  nt:=x.nt;
  nv:=x.nv;
  prev:=NIL;
  next:=NIL;
  End;
CreateNewListElement:=pn;
End;

Function ListAddNew(List:LongInt):Boolean;
Var pn,pp:pTListElement;
Begin
ListAddNew:=False;
pn:=aList[List].p;
If pn=NIL Then { empty list }
  Begin
  ListAddNew:=True;
  pn:=CreateNewListElement;
  With aList[List] Do
    Begin
    p:=pn;
    ItemCount:=1;
    ns:=x.n;
    nks:=x.nb;
    nvs:=x.nv;
    SortedBy:=Unsorted;
    C2:='u';
    End;
  End Else
  Begin { list is not empty, search list }
  While (pn^.s<>x.s) And (pn^.next<>NIL) Do pn:=pn^.next;
  If pn^.s=x.s Then
    Begin { element already in list }
    With aList[List] Do
      Begin
      ns:=ns+x.n;
      nks:=nks+x.nb;
      If (x.nt-pn^.nt)>=960 Then Inc(nvs);
      SortedBy:=Unsorted;
      C2:='u';
      End;
    With pn^ Do
      Begin
      If x.sEntry<>'' Then sEntry:=x.sEntry;
      n:=n+x.n;
      nb:=nb+x.nb;
      If (x.nt-nt)>=960 Then Inc(nv);
      nt:=x.nt;
      End;
    End Else
    Begin { element not yet in list }
    ListAddNew:=True;
    pn^.next:=CreateNewListElement;
    pp:=pn;
    pn:=pn^.next;
    With aList[List] Do
      Begin
      SortedBy:=Unsorted;
      C2:='u';
      Inc(ItemCount);
      ns:=ns+x.n;
      nks:=nks+x.nb;
      nvs:=nvs+x.nv;
      End;
    pn^.prev:=pp;
    End;
  End;
End;

Function ListFindString(List:LongInt;Var s:String):String;
Var p:pTListElement;
  k,l:LongInt;
  sn:String;
Begin
p:=alist[List].p;
While (p<>NIL) And (Pos(p^.s,s)<1) Do p:=p^.next;
If p=NIL Then
  Begin
  ListFindString:=ws[igrpws[hostgroup].ia+7];
  x.n:=1;
  x.nb:=1;
  x.nv:=1;
  x.s:=s;
  Case List Of
    ListBrowser:ListAddNew(ListBrowserU);
    ListOpSys:ListAddNew(ListOpSysU);
    End;
  End Else
  Begin
  l:=Length(s);
  sn:=p^.s;
  k:=Pos(sn,s)+Length(sn);
  While (k<=l) And {(s[k]<>' ') And} (s[k]<>')') And (s[k]<>';') And (s[k]<>'(') Do
    Begin
    sn:=sn+s[k];
    Inc(k);
    End;
  ListFindString:=sn;
  End;
End;

Begin
For k:=1 To nLists Do With alist[k] Do
  Begin
  p:=NIL;
  s:='';
  SortedBy:=Unsorted;
  c1:='_';
  c2:='u';
  ItemCount:=0;
  ns:=0;
  nks:=0;
  nvs:=0;
  End;
End.
