{$I+,V+,R+,S+,D+,I+,Q+}
{ WebLox main program for analyzing server logfiles
  (C)2001 by gerd@dg4fac.de Version 0.8
  created 06.05.2000 for fpk-Pascal under
  SuSe-Linux 6.4, last change 05.01.2002
}

Program weblox;

Uses Crt,Dos,SysUtils,webout,ip2url,webfiles,weblist,webstring,
     webeng,webvers,webua,weberr;

Const buffer_length=1024; { Input buffer for log lines }
      max_logfiles=100;   { max. number of logfiles to treat }

Var fbuf:Array[1..buffer_length] Of Char;
  f:File Of Char;
  ibp,in_read:LongInt;
  sl:Array[1..11] Of String;
{   1:String[15];  IP }
{   2:String[255];  USER 1, usually - }
{   3:String[255];  USER 2, if user is known }
{   4:String[22];  Date-Time-String }
{   5:String[7];  relative to UTC }
{   6:String[255];  command-string }
{   7:String[3];  return value 200=ok, 300=?, 301 moved, 304 not modified,
                  401 Unauthorized, 404 Not found }
{   8:String[9];  Length of file }
{   9:String[255];  URL log }
{  10:String[255];  Referrer file }
{  11:String[255];  User agent }

  sCurrent:String; { Current analysed logfile }
  sDefaultfile:String; { Default file if no filename is given }

  nl:LongInt; { number of lines processed }
  rbytes:Extended; { Number of bytes }

  alogs:Array[1..max_logfiles] Of String; { names of logfiles and number }
  nlogs:LongInt;

  dt,ha,he,ma,me,sa,se,s100a,s100e:Word; { operation time }

  slogfiles,slogpath:String; { Configuration variables }

  c:Char;

  sy:String; { Current year as String }

{ Init routines }

Function find_all_logs:Boolean;
Var sr:Dos.SearchRec;
  k:LongInt;
  s:String;
Begin
Write('Logfiles ... ');
nlogs:=0; { Find log files in logdir }
Dos.FindFirst(slogfiles,AnyFile,sr);
While DosError=0 Do
  Begin
  Inc(nlogs);
  alogs[nlogs]:=sr.name;
  Dos.FindNext(sr);
  End;
Dos.FindClose(sr);
k:=1; { Sort all logfiles in upward direction }
While k<nlogs Do
  Begin
  If alogs[k]<=alogs[k+1] Then Inc(k) Else
    Begin
    s:=alogs[k];
    alogs[k]:=alogs[k+1];
    alogs[k+1]:=s;
    If k>1 Then Dec(k);
    End;
  End;
Writeln(nlogs,ws[igrpws[msgGroup].ia]);
find_all_logs:=nlogs>0;
End;

{ Reformatting Strings and Numbers }

Function Monat(s:String):LongInt;
Begin
Case s[1] Of
  'J':Case s[2] Of
        'a':Monat:=1;
        'u':If s[3]='n' Then Monat:=6 Else Monat:=7;
        End;
  'F':Monat:=2;
  'M':If s[3]='r' Then Monat:=3 Else Monat:=5;
  'A':If s[2]='p' Then Monat:=4 Else Monat:=8;
  'S':Monat:=9;
  'O':Monat:=10;
  'N':Monat:=11;
  'D':Monat:=12;
  Else
  Monat:=0;
  End;
End;

Function sMonat(i:LongInt):String;
Var st:String;
Begin
If i=0 Then st:='mm' Else
  Begin
  Str(i,st);
  If Length(st)<2 Then st:='0'+st;
  End;
sMonat:=st;
End;

Function GetTimeFromString(Var s:String):DateTime;
Var dt:DateTime;
  e,es:Word;
Begin
es:=0;
With dt Do
  Begin
  Val(Copy(s,9,4),year,e);
  If e>0 Then es:=1;
  month:=Monat(Copy(s,5,3));
  If month=0 Then es:=es+2;
  If s[2]='0' Then Val(s[3],day,e) Else Val(Copy(s,2,2),day,e);
  If e>0 Then es:=es+4;
  If s[14]='0' Then Val(s[15],hour,e) Else Val(Copy(s,14,2),hour,e);
  If e>0 Then es:=es+8;
  If s[17]='0' Then Val(s[18],min,e) Else Val(Copy(s,17,2),min,e);
  If e>0 Then es:=es+16;
  If s[20]='0' Then Val(s[21],sec,e) Else Val(Copy(s,20,2),sec,e);
  If e>0 Then es:=es+32;
  If e>0 Then
    Begin
    Writeln;
    Writeln('Line: ',nl);
    Writeln(ws[igrpws[msgGroup].ia+1],s);
    WebErrOut(sCurrent,'Time: Ip='+sl[1]+', x2='+sl[2]+', x3='+sl[3]+', time='+sl[4]);
    Readkey;
    Halt(4);
    End;
  End;
GetTimeFromString:=dt;
End;

Procedure Str_Low_Case(Var s:String);
Var k:LongInt;
Begin
For k:=1 To Length(s) Do If (s[k]>='A') And (s[k]<='Z') Then
  s[k]:=Char(Byte(s[k])+32);
End;

{ Analyse one line of information from the logfile }

Procedure count_items;
Var k,l,m,t:LongInt;
  e:Word;
  s,sb,sext,sfn:String;
  nongra:Boolean;
  dt:DateTime;
{  f:Boolean;}
Begin
{f:=True;}
{ Get file length into l }
{If f Then Writeln('Start countitems');
If f Then For k:=1 To 5 Do Writeln('sl[',k,']=',sl[k]);}
If sl[8]='-' Then l:=0 Else
  Begin
  Val(sl[8],l,e);
  If e<>0 Then
    Begin
    Writeln;
    Writeln(ws[igrpws[msgGroup].ia+14],' ',nl);
    Writeln(ws[igrpws[msgGroup].ia+3],'String=',sl[8], 'IP= ',sl[1]);
    WebErrOut(sCurrent,'Error, line: '+IntToStr(nl)+', file length conversion, String= '+sl[8]+', IP= '+sl[1]);
    Readkey;
    Halt(5);
    End;
  End;
{If f Then Writeln('Adding rbytes');}
rbytes:=rbytes+l;
{ Get time information }
dt:=GetTimeFromString(sl[4]);
Dos.PackTime(dt,t);
{ get file name }
{If f Then Writeln('file name');}
s:=sl[6];
sb:='';
m:=1;
While s[m]<>' ' Do
  Begin
  sb:=sb+s[m];
  Inc(m);
  End;
nongra:=True;
If (sb='GET') Or (sb='HEAD') Then
  Begin
  If sb='GET' Then k:=5 Else k:=6;
  Repeat Inc(k) Until (k>Length(s)) Or (s[k]=' ');
  If sb='GET' Then sfn:=Copy(s,5,k-5) Else sfn:=Copy(s,6,k-6);
  If sfn[Length(sfn)]='/' Then sfn:=sfn+sDefaultfile;
  k:=Length(sfn);
  While (k>0) And (sfn[k]<>'.') Do Dec(k);
  If k>0 Then
    Begin
    sext:=Uppercase(Copy(sfn,k,4));
    nongra:=sext='.HTM';
    End Else
    sext:='';
  End Else
  Begin
  WebErrOut(sCurrent,'Unknown command in line '+IntToStr(nl)+': '+sb);
  Write('!');
  End;
{ get ip }
{If f Then Writeln('ip');}
x.s:=sl[1];
If nongra Then x.sEntry:=sfn Else x.sEntry:='';
x.n:=1;
{If f Then Writeln('l=',l);}
x.nb:=(l+512) DIV 1024;
{If f Then Writeln('x.nb=',x.nb);
If f Then Writeln('t=',t);}
x.nt:=t;
{If f Then Writeln('x.nt=',x.nt);}
x.nv:=1;
If ListAddNew(ListIp) And nongra Then
  Begin
  x.s:=sfn;
  ListAddNew(ListEntryPages);
  End;
x.s:=sfn;
ListAddNew(ListFiles);
{ get non graphics files }
{If f Then Writeln('Graphics');}
x.s:=sfn;
If nongra Then
  ListAddNew(ListFilesNonGra) Else
  Begin
  If sext='.GIF' Then ListAddNew(ListGif) Else
    Begin
    If Copy(sext,1,3)='.JP' Then ListAddNew(ListJpeg);
    End;
  End;
{ Get pathes }
k:=Length(sfn);
While (k>0) And (sfn[k]<>'/') Do Dec(k);
x.s:=Copy(sfn,1,k);
ListAddNew(ListPath);
{ get referrers }
{If f Then Writeln('referrers');}
s:='http://'+sl[9];
k:=Length(s);
If nongra Then
  Begin
  If Copy(sl[10],1,k)=s Then
    Begin { internal referrers }
    s:=Copy(sl[10],k+1,255);
    If s='' Then s:='/';
    x.s:=s;
    ListAddNew(ListRefi);
    End Else
    Begin { external referrers }
    If Not CheckEng(sl[10]) Then
      Begin
      x.s:=sl[10];
      ListAddNew(ListRefe);
      End;
    End;
  End;
{ get return codes }
{If f Then Writeln('return codes');}
x.s:=sl[7];
ListAddNew(Listrc);
If sl[7]='404' Then
  Begin
  x.s:=sfn;
  ListAddNew(List404);
  End;
{ get user agents }
{If f Then Writeln('User agents');}
x.s:=GetBrowserType(sl[11]);
ListAddNew(ListBt);
x.s:=ListFindString(ListBrowser,sl[11]);
ListAddNew(ListBv);
x.s:=ListFindString(ListOpSys,sl[11]);
ListAddNew(ListOp);
{ get hours }
{If f Then Writeln('hours');}
x.s:=Copy(sl[4],14,2);
ListAddNew(ListHours);
{If f Then Writeln('end of countitems');}
End;

Procedure output_results(runfile,swm,sy:String;run_mode:Byte);
Var i,k,l:LongInt;
Begin
ListAddUrlNames;
Write(ws[igrpws[msgGroup].ia+17],' ');
Case run_mode Of
  Run_mode_week:WebOutOpen(runfile,ws[igrpws[msgGroup].ia+5]+' '+swm+' '+ws[igrpws[msgGroup].ia+6]+' '+sy);
  Run_mode_month:WebOutOpen(runfile,ws[igrpws[msgGroup].ia+7]+' '+swm+' '+ws[igrpws[msgGroup].ia+6]+' '+sy);
  Run_mode_year:WebOutOpen(runfile,ws[igrpws[msgGroup].ia+8]+' '+sy);
  End;
{ treat access by ip }
WebOutList(ListIp,SortByNumber);
WebOutList(ListIp,SortByBytes);
{ Analyse visits }
l:=ListGetList(ListIp).ItemCount;
For k:=1 To l Do
  If ListGetElement(ListIp,k) And (x.nv>1) Then
    ListAddNew(ListMultVis);
WebOutList(ListMultVis,SortByVisits);
{ Analyse countries of origin }
For k:=1 To l Do
  If ListGetElement(ListIp,k) Then
    Begin
    i:=Length(x.s);
    If x.s[i]=')' Then x.s:=ws[igrpws[msgGroup].ia+9] Else
      Begin
      Repeat Dec(i) Until (i=0) Or (x.s[i]='.');
      x.s:=Copy(x.s,i+1,255);
      End;
    Str_Low_Case(x.s);
    ListAddNew(ListCountry);
    End;
WebOutList(ListCountry,SortByNumber);
{ Treat all pathes }
WebOutList(ListPath,SortByNumber);
WebOutList(ListPath,SortByBytes);
{ treat all files }
WebOutList(ListFiles,SortByNumber);
WebOutList(ListFiles,SortByBytes);
{ treat all pages }
WebOutList(ListFilesNonGra,SortByNumber);
WebOutList(ListFilesNonGra,SortByBytes);
{ treat graphics files }
WebOutList(ListJpeg,SortByNumber);
WebOutList(ListGif,SortByNumber);
{ treat entry and cheat pages }
WebOutList(ListEntryPages,SortByNumber);
l:=ListGetList(ListIp).ItemCount;
For k:=1 To l Do
  If ListGetElement(ListIp,k) Then
    Begin
    x.n:=1;
    x.s:=x.sEntry;
    ListAddNew(ListCheatPages);
    End;
WebOutList(ListCheatPages,SortByNumber);
{ Internal referrers }
WebOutList(ListRefI,SortByNumber);
{ External referrers }
WebOutList(ListRefE,SortByNumber);
{ Search Engines }
WebOutList(ListSE,SortByNumber);
{ Search Strings }
WebOutList(ListST,SortByNumber);
{ Return codes }
l:=ListGetList(ListRc).ItemCount;
For k:=1 To l Do
  Begin
  If ListGetElement(ListRc,k) Then
    Begin
    i:=igrpws[rcGroup].ie;
    While (Copy(ws[i],1,3)<>x.s) And (i>igrpws[rcGroup].ia) Do Dec(i);
    If i<=igrpws[rcGroup].ia Then
      Begin
      WebErrOut(sCurrent,'Unknown return code in line '+IntToStr(nl)+': '+x.s);
      Writeln(ws[igrpws[msgGroup].ia+15],' ',x.s,'!');
      End;
    ListExchStr(ListRc,x.s,ws[i]);
    End;
  End;
WebOutList(ListRc,SortByNumber);
{ Files not found }
WebOutList(List404,SortByNumber);
{ User agents }
WebOutList(ListBt,SortByNumber);
{ Browser versions }
WebOutList(ListBv,SortByNumber);
{ Operating systems }
WebOutList(ListOp,SortByNumber);
{ hourly traffic }
WebOutList(ListHours,SortByString);
{ Total bytes }
WebOutClose(Round(rBytes/1024.0));
ListClearAll;
rbytes:=0.0;
Writeln(ws[igrpws[msgGroup].ia+18]);
End;

Function get_string_from_buffer(Var s:String):Boolean;
Var bracket,eos:Boolean;
  c:Char;
Begin
s:='';
bracket:=False;
eos:=False;
Repeat
  If ibp>in_read Then
    Begin
    If in_read<buffer_length Then ibp:=-1 Else
      Begin
      Blockread(f,fbuf,buffer_length,in_read);
      If in_read>20 Then ibp:=1 Else ibp:=-1;
      End;
    End;
  If ibp>0 Then
    Begin
    c:=fbuf[ibp];
    Inc(ibp);
    If c=Char(0) Then ibp:=-1 Else
      Begin
      If c=Char(10) Then eos:=True Else
        Begin
        If c='"' Then bracket:=Not bracket Else
          Begin
          If (bracket And (c<>Char(10))) Or (c<>' ') Then s:=s+c Else eos:=True;
          End;
        End;
      End;
    End;
  Until (ibp=-1) Or (eos);
get_string_from_buffer:=ibp>0;
End;

Function xtractline:LongInt;
Var n:LongInt;
  s:String;
  b:Boolean;
Begin
n:=0;
Repeat
  b:=get_string_from_buffer(s);
  If b Then
    Begin
    Inc(n);
    sl[n]:=s;
    End;
  Until (Not b) Or (n=11);
xtractline:=n;
End;

Procedure getlogs_weeks;
Var k,ks:LongInt;
  sw:String;
Begin
Writeln(ws[igrpws[msgGroup].ia+10],' W');
ks:=1;
While (ks<=nlogs) And (alogs[ks]<slogf[Run_Mode_Week]) Do Inc(ks);
Writeln('Start: ',ks,' File: ',alogs[ks],' Startfile: ',slogf[Run_Mode_Week]);
For k:=ks To nlogs Do
  Begin
  sCurrent:=slogpath+alogs[k];
  Write(ws[igrpws[msgGroup].ia+11],' ',alogs[k],' ... ');
  System.Assign(f,slogpath+alogs[k]);
  System.Reset(f,1);
  nl:=0;
  in_read:=Buffer_Length;
  ibp:=in_read+1;
  While xtractLine>0 Do
    Begin
    sy:=Copy(sl[4],9,4);
    sw:=Copy(alogs[k],Length(alogs[k])-1,2);
    count_items;
    Inc(nl);
    End;
  System.Close(f);
  Dec(nl);
  Writeln(nl,ws[igrpws[msgGroup].ia+12]);
  FileSetResult(run_mode_week,sy+'w'+sw,k<nlogs,alogs[k]);
  output_results(sy+'w'+sw,sw,sy,run_mode_week);
  End;
End;

Procedure getlogs_months;
Var k,ks:Byte;
  soldy,sm,soldm:String;
  fc:Boolean;
Begin
soldy:='';
soldm:='';
Writeln(ws[igrpws[msgGroup].ia+10],' M');
ks:=1;
While (ks<=nlogs) And (alogs[ks]<slogf[Run_Mode_Month]) Do Inc(ks);
Writeln('File: ',alogs[ks],' Startfile: ',slogf[Run_Mode_Month]);
For k:=ks To nlogs Do
  Begin
  sCurrent:=slogpath+alogs[k];
  Write(ws[igrpws[msgGroup].ia+11],' ',alogs[k],' ... ');
  System.Assign(f,slogpath+alogs[k]);
  System.Reset(f,1);
  nl:=0;
  in_read:=Buffer_Length;
  ibp:=in_read+1;
  While xtractLine>0 Do
    Begin
    Inc(nl);
    sy:=Copy(sl[4],9,4);
    If soldy='' Then soldy:=sy;
    sm:=sMonat(Monat(Copy(sl[4],5,3)));
    If soldm='' Then soldm:=sm;
    If nl=1 Then fc:=((sy+'m'+sm)>=actual[Run_Mode_Month]);
    If soldm<>sm Then
      Begin
      If fc Then
        Begin
        FileSetResult(run_mode_month,soldy+'m'+soldm,True,alogs[ks]);
        ks:=k;
        output_results(soldy+'m'+soldm,soldm,soldy,run_mode_month);
        End;
      soldy:=sy;
      soldm:=sm;
      fc:=(sy+'m'+sm)>=actual[Run_Mode_Month];
      End;
    If fc Then count_items;
    End;
  System.Close(f);
  Writeln(nl,ws[igrpws[msgGroup].ia+12]);
  If k=nlogs Then
    Begin
    FileSetResult(run_mode_month,sy+'m'+sm,False,alogs[ks]);
    output_results(sy+'m'+sm,sm,sy,run_mode_month);
    End;
  End;
End;

Procedure getlogs_years;
Var k,ks:Byte;
  soldy:String;
  fc:Boolean;
Begin
soldy:='';
Writeln(ws[igrpws[msgGroup].ia+10],' Y');
ks:=1;
While (ks<=nlogs) And (alogs[ks]<slogf[Run_Mode_Year]) Do Inc(ks);
Writeln('File: ',alogs[ks],' Startfile: ',slogf[Run_Mode_Year]);
For k:=ks To nlogs Do
  Begin
  {If k=nlogs Then Writeln('Start last logfile');}
  sCurrent:=slogpath+alogs[k];
  Write(ws[igrpws[msgGroup].ia+11],' ',alogs[k],' ... ');
  {If k=nlogs Then Writeln('Open log file');}
  System.Assign(f,slogpath+alogs[k]);
  System.Reset(f,1);
  nl:=0;
  in_read:=Buffer_Length;
  ibp:=in_read+1;
  {If k=nlogs Then Writeln('Extract first line');}
  While xtractLine>0 Do
    Begin
    Inc(nl);
    {If k=nlogs Then Writeln('Extracted line: ',nl);}
    sy:=Copy(sl[4],9,4);
    If soldy='' Then soldy:=sy;
    If nl=1 Then fc:=((sy+'y')>=actual[Run_Mode_Year]);
    If soldy<>sy Then
      Begin
      If fc Then
        Begin
        FileSetResult(run_mode_year,soldy+'y',True,alogs[ks]);
        ks:=k;
        output_results(soldy+'y','00',soldy,run_mode_year);
        End;
      soldy:=sy;
      fc:=(sy+'y')>=actual[Run_Mode_Year];
      End;
    If fc Then count_items;
    End;
  System.Close(f);
  Writeln(nl,ws[igrpws[msgGroup].ia+12]);
  If k=nlogs Then
    Begin
    FileSetResult(run_mode_year,sy+'y',False,alogs[ks]);
    output_results(sy+'y','00',sy,run_mode_year);
    End Else
    Begin
    CheckDns(True);
    End;
  End;
End;

{ Configuration file operations }

Procedure Clean_Word(Var s:String);
Begin
While (s[1]=' ') Or (s[1]='=') Do Delete(s,1,1);
While (s[Length(s)]=' ') Or (s[Length(s)]='=') Do
  Delete(s,Length(s),1);
End;

Function extract_conf_line(Var s,s1,s2:String):Boolean;
Var k,l:Byte;
Begin
s1:='';
s2:='';
k:=Pos(' ',s);
l:=Pos('=',s);
If (l<1) Then
  Begin
  If k>0 Then
    Begin
    s1:=Copy(s,1,k-1);
    s2:=Copy(s,k+1,255);
    Clean_Word(s1);
    Clean_Word(s2);
    End;
  End Else
  Begin
  s1:=Copy(s,1,l-1);
  s2:=Copy(s,l+1,255);
  Clean_Word(s1);
  Clean_Word(s2);
  End;
extract_conf_line:=(s1<>'') And (s2<>'');
End;

Function getconf:Boolean;
Const
  nconfnames=25;
  sconfnames:Array[1..nconfnames] Of String =
    ('logfiles','Analyse_Years','Host_Url','Defaultfile','Errlogfile',
    'targetdir','Host_file','Host_notfound','Browser','OpSys','Results',
    'no_text_out','htmldir','no_html_out','no_html_index','no_html_week',
    'no_html_month','no_html_year','html_robots','html_bgcolor',
    'html_tables','html_copyright','Lang_file','decsep','ksep');
  plogfiles=1;
  pAnalyseYears=2;
  pHostUrl=3;
  pDefaultfile=4;
  pErrlogfile=5;
  ptargetdir=6;
  pHostFile=7;
  pHostNotFound=8;
  pBrowser=9;
  pOpSys=10;
  pResults=11;
  pNoTextOut=12;
  pHtmlDir=13;
  pNoHtmlout=14;
  pNoHtmlIndex=15;
  pNoHtmlWeek=16;
  pNoHtmlMonth=17;
  pNoHtmlYear=18;
  pHtmlRobots=19;
  pHtmlBgcolor=20;
  pHtmlTables=21;
  pHtmlCopyRight=22;
  pLang=23;
  pDecSep=24;
  pksep=25;
Var s,s1,s2,sconf:String;
  sr:SearchRec;
  f:Text;
  k,nl:LongInt;
  e:Word;
Begin
sDefaultfile:='index.html';
slogfiles:='';
fAnalyseYears:=False;
stargetdir:='';
sconf:='';
sLangFile:='';
sBrowserName:='';
sOpSysName:='';
FileResults:='';
sWebErrFileName:='';
Case ParamCount of
  0: sconf:='weblox.conf';
  1: sconf:=ParamStr(1);
  Else
  Writeln('Too many parameters on command line! Only the path/name of the');
  Writeln('configuration file is allowed!');
  Writeln('Zu viele Parameter in der Aufrufzeile! Nur der Pfad/Name der');
  Writeln('Konfigurationsdatei sind erlaubt!');
  Readkey;
  Halt(2);
  End;
Write('Searching file/Suche Datei ',sconf,' ... ');
Dos.Findfirst(sconf,AnyFile,sr);
If DosError<>0 Then
  Begin
  Dos.FindClose(sr);
  Writeln('failed!');
  Writeln('Create weblox.conf file either in the current directory',
    ' and call weblox again OR');
  Writeln('create such a file in another directory and call weblox',
    ' again with the path');
  Writeln(' and name of this file as the sole parameter!');
  Writeln('Suche gescheitert! Die Datei weblox.conf entweder im',
    ' aktuellen Pfad erzeugen ODER');
  Writeln('eine Konfigurationsdatei erzeugen und deren Pfad/Name in',
    ' der Aufrufzeile angeben.');
  Readkey;
  Halt(3);
  End;
Dos.FindClose(sr);
Writeln('found.');
Write('Reading config file / Lesen der Konfig-Datei ... ');
System.Assign(f,sconf);
System.Reset(f);
nl:=0;
While Not Eof(f) Do
  Begin
  Readln(f,s);
  Inc(nl);
  If (s<>'') And (s[1]<>'#') And (s[1]<>'/') And (s[1]<>'*') Then
    Begin
    If extract_conf_line(s,s1,s2) Then
      Begin
      k:=1;
      While (k<=nconfnames) And (s1<>sconfnames[k]) Do Inc(k);
      Case k Of
        plogfiles:slogfiles:=s2;
        pAnalyseYears:fAnalyseYears:=(s2='yes');
        pHostUrl:sHostUrl:=s2;
        pDefaultfile:sDefaultfile:=s2;
        pErrlogfile:sWebErrFileName:=s2;
        ptargetdir:stargetdir:=s2;
        pHostFile:sHostFile:=s2;
        pHostNotFound:fHostNotFound:=True;
        pBrowser:sBrowserName:=s2;
        pOpSys:sOpSysName:=s2;
        pResults: FileResults:=s2;
  	pNoTextOut:OutputFlags.text_out:=Not (s2='yes');
  	pHtmlDir:sHtmlDir:=s2;
        pNoHtmlout:OutputFlags.html_out:=Not (s2='yes');
        pNoHtmlIndex:OutputFlags.html_index:=Not (s2='yes');
        pNoHtmlWeek:OutputFlags.html_week:=Not (s2='yes');
        pNoHtmlMonth:OutputFlags.html_month:=Not (s2='yes');
        pNoHtmlYear:OutputFlags.html_year:=Not (s2='yes');
        pHtmlRobots:sHtmlRobots:=s2;
        pHtmlBgColor:sHtml.bgcolor:=s2;
        pHtmlTables:Val(s2,sHtml.iTables,e);
        pHtmlCopyRight:sHtml.Copyright:=s2;
        pLang:sLangFile:=s2;
        pdecsep:cdecsep:=s2[1];
        pksep:cksep:=s2[1];
        Else
        Writeln;
        Writeln('Config variable not found!');
        Writeln('Konfigurationsbezeichner nicht gefunden!');
        Writeln('Variable=',s1,' Parameter=',s2);
        Writeln('Line ',nl,' in conf file will be ignored!');
        Writeln('Zeile ',nl,' in der Konfigurationsdatei wird ignoriert!');
        End;
      End Else
      Begin
      Writeln('Illegal expression, line ',nl,' of conf file:');
      Writeln('Ungltiger Ausdruck, Zeile ',nl,' der Konfigurationsdatei:');
      Writeln('>>',s);
      Writeln(sconf,', line ignored!');
      Writeln(sconf,', Zeile wird ignoriert!');
      End;
    End;
  End;
System.Close(f);
Writeln(' done.');
If sLangFile='' Then
  Begin
  Writeln('Language file missing! Execution terminated!');
  Writeln('Keine Sprachdatei gefunden! Abbruch!');
  End Else
  ReadLangStrings;
If sHostFile='' Then shostfile:=sTargetDir+'/host.dat';
If sBrowserName='' Then
  Writeln('Warning! No browser version file defined!') Else
  ReadBrowsers;
If sOpSysName='' Then
  Writeln('Warning! No operating system file defined!') Else
  ReadOpSys;
If FileResults='' Then
  Begin
  Writeln('Warning! Result-file undefined! Using default file results.txt!');
  FileResults:='results.txt';
  End;
If sWebErrFileName='' Then
  Begin
  Writeln('Warning! Errlog-file undefined! Using default file errlog.txt!');
  sWebErrFileName:='errlog.txt';
  End;
sAbbrev:=ws[igrpws[tGroup].ia];
For k:=1 To nLists+1 Do
  aTitle[k]:=ws[igrpws[tGroup].ia+k];
sSortAbbrev:=ws[igrpws[sortGroup].ia];
For k:=1 To nSortOpts Do
  sSortOpt[k]:=ws[igrpws[sortGroup].ia+k];
For k:=1 To nlists Do
  Begin
  ListSetTitle(k,aTitle[k]);
  ListSetC1(k,sAbbrev[k]);
  End;
slogpath:=slogfiles;
If (slogpath<>'') Then
  Begin
  While (slogpath<>'') And (slogpath[Length(slogpath)]<>'/') Do
    Delete(slogpath,Length(slogpath),1);
  End;
getconf:=(slogfiles<>'') And (stargetdir<>'');
End;

Begin
GetTime(ha,ma,sa,s100a);
Writeln;
Writeln('--------------------------------------------------');
Writeln('Weblox Version '+WebLoxVersion+' (C)2000-2002 by gerd@dg4fac.de');
Writeln('--------------------------------------------------');
rbytes:=0.0;
sCurrent:='';
sHostFile:='host.dat';
fHostNotFound:=False;
If getconf And find_all_logs Then
  Begin
  WebErrOpen;
  CheckDns(False);
  If Not fDnsOk Then
    Begin
    WebErrOut('','Warning! DNS not available');
    Write(ws[igrpws[msgGroup].ia+19],' ');
    Repeat c:=Upcase(Readkey) Until (c='J') Or (c='Y') Or (c='N');
    If c='N' Then
      Begin
      WebErrOut('','Stopped by user action');
      Writeln('stopped.');
      WebErrClose;
      Halt(1);
      End;
    Writeln(ws[igrpws[msgGroup].ia+20]);
    End;
  ReadAllHosts;
  FileReadLists;
  Getlogs_weeks;
  CheckDns(True);
  If fDnsOk Then SaveAllHosts;
  Getlogs_months;
  CheckDns(True);
  If fDnsOk Then SaveAllHosts;
  If fAnalyseYears Then
    Begin
    Getlogs_Years;
    CheckDns(True);
    If fDnsOk Then SaveAllHosts;
    End Else
    Begin
    FileSetResult(run_mode_year,sy+'y',False,alogs[1]);
    End;
  WebDetail;
  WebStatIndex;
  WriteUnknownBrowsersOpSys;
  FileSaveCloseLists;
  ListClearAll;
  ListClearProtectedLists;
  End;
DeleteAllIps;
WebErrClose;
GetTime(he,me,se,s100e);
dt:=se-sa+60*(me-ma+60*(he-ha));
Writeln(ws[igrpws[msgGroup].ia+13],' ',dt);
Write(ws[igrpws[msgGroup].ia+14]);
ReadKey;
Writeln;
End.
